#!/usr/local/bin/perl

#------------------------------------------------------------------------------#
# 'Mireille' Bulletin Board System
# - Mireille Administrative Tools -
#
# $Revision: 1.2.2.20 $
# "This file is written in euc-jp, CRLF." 
# Scripted by NARUSE Yui.
#------------------------------------------------------------------------------#
# $cvsid = q$Id: manage.cgi,v 1.2.2.20 2002/05/10 13:47:08 naruse Exp $;
require 5.005;
use Fcntl qw(:DEFAULT :flock);
use strict;
use vars qw(%AT %CF %IN %IC @file @zer2);
$|=1;

#CGIΥѥ
$AT{'pass'}='';

#-------------------------------------------------
# Switch
unless(&getfm){
  &menu('NULL');
}elsif('icont'eq$IN{'mode'}){
  &icont;
}elsif('icons'eq$IN{'mode'}){
  &icons;
}elsif('iconsmp'eq$IN{'mode'}){
  &iconsmp;
}elsif('config'eq$IN{'mode'}){
  &config;
}elsif('css'eq$IN{'mode'}){
  &css;
}elsif('log'eq$IN{'mode'}){
  &log;
}elsif('zero'eq$IN{'mode'}){
  &zero;
}elsif('manage'eq$IN{'mode'}){
  &manage;
}else{
  &menu('NG');
}
exit;

#-------------------------------------------------
# Get Form
sub getfm{
  my$i='';my%DT;
  unless($ENV{'REQUEST_METHOD'}){}
  elsif('POST'eq$ENV{'REQUEST_METHOD'}){read(STDIN,$i,$ENV{'CONTENT_LENGTH'});}
  elsif('GET'eq$ENV{'REQUEST_METHOD'}){$i=$ENV{'QUERY_STRING'};}
  foreach(split('&',$i)){
    my($i,$j)=split('=',$_,2);
    (defined$j)||($IN{$i}="",next);
    study$j;
    $j=~tr/+/ /;
    $j=~s/%([0-9A-Fa-f]{2})/pack('H2',$1)/ego;
    $j=~s/\x0D\x0A/\n/go;
    $j=~tr/\r/\n/; # ̣Ūˤ tr/\x0D\x0A/\n\n/;
    $DT{$i}=$j;
  }
  # Header with G-ZIP etc.
  print<<'_HTML_';
Content-type: text/html; charset=euc-jp
Content-Language: ja-JP

_HTML_
  # Password Check
  ($DT{'mode'})||(return undef);
  ($DT{'pass'}eq$AT{'pass'})||(&menu('Passwordפޤ'));
  $IN{'pass'}=($DT{'pass'}=~/(.+)/o)?"$1":'';
  $IN{'mode'}=$DT{'mode'};
  if('icont'eq$DT{'mode'}){
    $IN{'icon'}=($DT{'icon'}=~/(.+)/os)?"$1":undef;
    $IN{'renew'}=($DT{'renew'}=~/(.)/o)?'1':undef;
    return%IN;
  }elsif('icons'eq$DT{'mode'}){
    $IN{'icon'}=($DT{'icon'}=~/(.+)/os)?"$1":undef;
    $IN{'renew'}=($DT{'renew'}=~/(.)/o)?'1':undef;
    return%IN;
  }elsif('iconsmp'eq$DT{'mode'}){
    return%IN;
  }elsif('config'eq$DT{'mode'}){
    while(my($i,$j)=each%DT){
      $IN{"$i"}=($j=~/(.*)/os)?"$1":undef;
    }
    return%IN;
  }elsif('css'eq$DT{'mode'}){
    $IN{'css'}=($DT{'css'}=~/(.+)/os)?"$1":undef;
    $IN{'file'}=($DT{'file'}=~/(\w+)/o)?"$1":undef;
    $IN{'code'}=($DT{'code'}=~/(\w+)/o)?"$1":undef;
    return%IN;
  }elsif('log'eq$DT{'mode'}){#LOG
    $IN{'str'}=($DT{'str'}=~/(\d+)/o)?$1:0;
    $IN{'end'}=($DT{'end'}=~/(\d+)/o)?$1:0;
    $IN{'del'}=($DT{'del'}=~/(\w)/o)?"$1":undef;
    $IN{'save'}=($DT{'save'}=~/(\d+)/o)?$1:0;
    $IN{'push'}=($DT{'push'}=~/(\d)/o)?"$1":'';
    $IN{'type'}=($DT{'type'}=~/(\w)/o)?"$1":undef;
    return%IN;
  }elsif('zero'eq$DT{'mode'}){#Zero
    $IN{'recover'}=($DT{'recover'}=~/(.)/o)?'1':undef;
    return%IN;
  }elsif('manage'eq$DT{'mode'}){#Manage
    $IN{'manage'}=($DT{'manage'}=~/(\w+)/o)?$1:undef;
    $IN{'filename'}=($DT{'filename'}=~/([^\\\/:*?"<>|]+)/o)?$1:undef;
    return%IN;
  }
  print"<pre>something wicked happend!\n";
  print"餯ϥե륿ߥ\nCGI".__LINE__."ܤǤΥ顼";
  exit;
}

#-------------------------------------------------
# Menu
sub menu{
  print<<"ASDF";
$AT{'head'}<h2 class="mode" style="margin:1em">[ $_[0] ]</h2>
<form accept-charset="euc-jp" name="menu" method="post" action="$AT{'manage'}">
<fieldset style="text-align:left;padding:0.5em;width:15em">
<legend>Mode</legend>
<label accesskey="y" for="icont">
<input name="mode" class="radio" id="icont" type="radio" value="icont">
IconꥹԽʥ(<span class="ak">Y</span>)</label>
<br>
<label accesskey="u" for="icons">
<input name="mode" class="radio" id="icons" type="radio" value="icons">
IconꥹԽ(Sharp(<span class="ak">U</span>)</label>
<br>
<label accesskey="i" for="iconsmp">
<input name="mode" class="radio" id="iconsmp" type="radio" value="iconsmp" checked>
<span class="ak">I</span>conܤ򹹿</label>
<br>
<label accesskey="g" for="config">
<input name="mode" class="radio" id="config" type="radio" value="config">
index.cgiԽ(<span class="ak">G</span>)</label>
<br>
<label accesskey="b" for="css">
<input name="mode" class="radio" id="css" type="radio" value="css">
CSSԽ(<span class="ak">B</span>)</label>
<br>
<label accesskey="l" for="log">
<input name="mode" class="radio" id="log" type="radio" value="log">
<span class="ak">L</span>OG</label>
<br>
<label accesskey="z" for="zero">
<input name="mode" class="radio" id="zero" type="radio" value="zero">
ե(<span class="ak">Z</span>)</label>
<br>
<label accesskey="m" for="manage">
<input name="mode" class="radio" id="manage" type="radio" value="manage">
CGIδ(<span class="ak">M</span>)</label>
</fieldset>
<p><label accesskey="p" for="pass"><span class="ak">P</span>assword:
<input name="pass" id="pass" type="password" size="12" value="$IN{'pass'}"></label></p>
<p><input type="submit" accesskey="s" class="submit" value="OK">
<input type="reset" class="reset" value="󥻥"></p>
$AT{'foot'}
ASDF
  exit;
}

#-------------------------------------------------
# ʥ
sub icont{
  &loadcfg;
  unless($IN{'icon'}){#ꥹԽ
    open(RD,"<$CF{'icls'}")||die"Can't read iconlist($CF{'icls'})[$!]";
    eval"flock(RD,1);";
    my$icon=join('',<RD>);
    close(RD);
    $icon=~s/\t/\ \ /go;
    $icon=~s/[\x0D\x0A]*$//o;
    print<<"ASDF";
$AT{'head'}
<h2 class="mode">ꥹԽ⡼</h2>
<form accept-charset="euc-jp" name="iconedit" method="post" action="$AT{'manage'}">
<p><textarea name="icon" cols="100" rows="15">$icon</textarea></p>
<p><label accesskey="r" for="renew">ܹ(<span class="ak">R</span>):
<input name="renew" id="renew" type="checkbox" value="renew" checked></label></p>
<input name="mode" type="hidden" value="icont">
<input name="pass" type="hidden" value="$IN{'pass'}">
<input type="submit" accesskey="s" class="submit" value="OK"></p>
$AT{'foot'}
ASDF
  exit;
  }else{#ꥹȽ񤭹 Tag
    study$IN{'icon'};
    $IN{'icon'}=~tr/\n//s;
    $IN{'icon'}=~s/(\n)*$/\n/;

    open(WR,"+>>$CF{'icls'}")||die"Can't write iconlist($CF{'icls'})[$!]";
    eval"flock(WR,2);";
    truncate(WR,0);
    seek(WR,0,0);
    print WR $IN{'icon'};
    close(WR);

    unless($IN{'renew'}){
      &menu('ꥹȽ񤭹ߴλ');
    }else{
      &iconsmp;
      &menu('ꥹȡܽ񤭹ߴλ');
    }
  }
  exit;
}

#-------------------------------------------------
# ʡ
sub icons{
  &loadcfg;
  unless($IN{'icon'}){
    #ꥹSharpԽ
    print<<"ASDF";
$AT{'head'}
<h2 class="mode">ꥹԽ⡼</h2>
<form accept-charset="euc-jp" name="iconedit" method="post" action="$AT{'manage'}">
<p><textarea name="icon" cols="100" rows="15">
ASDF
    
    open(RD,"<$CF{'icls'}")||die"Can't read iconlist($CF{'icls'})[$!]";
    eval"flock(RD,1);";
    my@icon=<RD>;
    close(RD);
    
    my$optg=0;
    
    for(@icon){
      
      if($_=~m{^\s*<option .*?\bvalue=(["'])(.+?)\1.*?>([^<]*)(</option>)?$}io){
        if($optg==1){print"\ \ ";}
        elsif($optg==2){print"#\n";$optg=0;}
        print"$2#$3\n";
        next;
      }elsif($_=~m{<optgroup .*\blabel=(["'])(.+?)\1.*>}io){
        ($2)||($optg=0);
        $optg=1;
        print"#$2\n";
        next;
      }elsif($_=~m{</optgroup>}io){
        print"#\n";
        $optg=2;
        next;
      }else{
        print"$_";
      }
    }
    
    print<<"ASDF";
</textarea></p>
<p><label accesskey="r" for="renew">ܹ(<span class="ak">R</span>):
<input name="renew" id="renew" type="checkbox" value="renew" checked></label></p>
<input name="mode" type="hidden" value="icons">
<input name="pass" type="hidden" value="$IN{'pass'}">
<input type="submit" accesskey="s" class="submit" value="OK"></p>
$AT{'foot'}
ASDF
    
    exit;
  }else{
    #ꥹȽ񤭹
#    study$IN{'icon'};
    $IN{'icon'}=~tr/\n//s;
#    $IN{'icon'}=~s/&/&#38;/go;
#    $IN{'icon'}=~s/"/&#34;/go;
#    $IN{'icon'}=~s/'/&#39;/go;
#    $IN{'icon'}=~s/</&#60;/go;
#    $IN{'icon'}=~s/>/&#62;/go;
    my@icon=split("\n","$IN{'icon'}");
    
=icon Sharp
 GroupName
^\s*\#\s*(.*)$
 IconName
^\s*([^#])\s*#\s*(.*)$
=cut
    
    open(WR,"+>>$CF{'icls'}")||die"Can't write iconlist($CF{'icls'})[$!]";
    eval"flock(WR,2);";
    truncate(WR,0);
    seek(WR,0,0);
    my$optg=0;
    for(@icon){
      if($_=~m/^\s*\#\s*(.*)$/o){
        #󥰥롼
        ($optg==1)&&(print WR "</optgroup>\n");
        ($1)||($optg=0,next);
        print WR qq[<optgroup label="$1">\n];
        $optg=1;
        next;
      }elsif($_=~m/^\s*([^#]*)\s*\#\s*(.*)$/o){
        #
        ($optg==1)&&(print WR "\ \ ");
        print WR qq[<option value="$1">$2</option>\n];
        next;
      }else{
        print WR "$_\n";
      }
    }
    ($optg==1)&&(print WR "</optgroup>\n");
    close(WR);
    
    unless($IN{'renew'}){
      &menu('ꥹȽ񤭹ߴλ');
    }else{
      &iconsmp;
      &menu('ꥹȡܽ񤭹ߴλ');
    }
    exit;
  }
}

#-------------------------------------------------
# ܹ
sub iconsmp{
  &loadcfg;
  open(RD,"<$CF{'icls'}")||die"Can't read iconlist($CF{'icls'})[$!]";
  eval"flock(RD,1);";
  my@icon=<RD>;
  close(RD);
  
  #OPTGROUP
  #^<optgroup (.*)label=(["'])(.+?)\2(.*)>$
  #<table $1summary="$2"$3>
  #{^</optgroup>$}{</tr></table>}
  #OPTION
  #^\s*<option (.*)value=(["'])(.+?)\2([^>]*)>([^<]*)(</option>)?$
  #<td><img $1src="$CF{'icon'}$2" alt=\"$1\"$3><br>$1</td>
  open(WR,'+>>icon.html')||die"Can't write iconsample(icon.html)[$!]";
  eval"flock(WR,2);";
  truncate(WR,0);
  seek(WR,0,0);
  print WR <<"_HTML_";
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja-JP">
<head>
<meta http-equiv="Content-type" content="text/html; charset=euc-jp">
<meta http-equiv="Content-Script-Type" content="text/javascript">
<meta http-equiv="Content-Style-Type" content="text/css">
<link rel="stylesheet" type="text/css" href="$CF{'style'}" media="screen" title="DefaultStyle">
<link rel="start" href="$CF{'home'}">
<link rel="index" href="index.cgi">
<title>: Mireille Icon List :</title>
</head>
<body style="margin-top:1em">
_HTML_
  print WR $CF{'pghead'};
  eval qq{print WR <<"_HTML_";\n$CF{'menu'}\n_HTML_};
  print WR qq[<h2 class="mode"></h2>\n$CF{'iched'}];

  my$i=0;
  my$j=0;
  my@others=();
  $AT{'x'}=6;
  my%CR;
  
=item

#OPTION
if($i==0){֤¾}
elsif($i==1and$j==0){OPTGROUPǺǽOPTION}
elsif($i==2and$j==0){OPTGROUPǲľOPTION}
elsif($i==1and$j=~/[1-5]/){֤¾OPTION}

#OPTGOUP
OPTGROUPä

#/OPTGOUP
OPTGROUP˽Ф

=cut
  
  for(@icon){
    my$text;
    if($_=~m{^\s*<option (.*)value=(["'])(.+?)\2([^>]*)>([^<]*)(</option>)?$}io){
      if($i){#optgroup
        $j++;
        if($j){#<td>
          ($j>($AT{'x'}-2))&&($j=-1);
        }elsif($i==2){#</tr>+<tr>+<td>
          $text="</tr>\n<tr>\n";
        }elsif($i==1){#<tr>+<td>
          $text="<tr>\n";
          $i=2;
        }else{next;}
        $text.=qq(<td><img $1src="$CF{'icon'}$3" alt="$5"$4><br>$5</td>\n);
        print WR $text;next;
      }else{#others
        push(@others,$_);next;
      }
    }elsif($_=~m{^<optgroup (.*)label=(["'])(.+?)\2(.*)>$}io){
      $text=<<"_HTML_";
<table $1cellspacing="0" class="icon" summary="$3"$4>
<caption>$3</caption>
<col span="$AT{'x'}" width="110" />
_HTML_
      $i=1;$j=-1;print WR $text;next;
    }elsif($_=~/optgroup/io){#</optgroup>
      if($CR{'VENDOR_LINK'}&&$CR{'COPY1_LINK'}){
        $text="&#169;$CR{'COPY1_LINK'} &gt;&gt; by$CR{'VENDOR_LINK'}";
      }elsif($CR{'VENDOR_LINK'}){
        $text="by$CR{'VENDOR_LINK'}";
      }elsif($CR{'COPY1_LINK'}){
        $text="&#169;$CR{'COPY1_LINK'}";
      }else{next;}
      $text=<<"_HTML_";
</tr>
<tr><th colspan="$AT{'x'}" class="foot">$text</th></tr>
</table>

_HTML_
      $i=0;print WR $text;next;
    }elsif($_=~/<!-- %([A-Z0-9]+_)?(VENDOR|COPY1)(_[A-Z0-9]+)?( (.*?))?\s*-->/o){

=item

$1: 'BEGIN_','END_'
$2: 'VENDOR','COPY1'
$3: '_NAME','_URL','_LINK'
$4: 

=cut
      if('BEGIN_'eq$1){
        $CR{$2.'_NAME'}='';$CR{$2.'_URL'}='';$CR{$2.'_LINK'}='';
        if($4){$CR{$2.'_NAME'}=$4;}else{next;}
      }elsif('END_'eq$1){
        $CR{$2.'_NAME'}='';$CR{$2.'_URL'}='';$CR{$2.'_LINK'}='';next;
      }elsif($3){
        if('_NAME'eq$3){
          $CR{$2.'_NAME'}=$4;
          ($CR{$2.'_LINK'})&&(next);
        }elsif('_URL'eq$3){
          $CR{$2.'_URL'}=$4;
        }elsif('_LINK'eq$3){
          $CR{$2.'_LINK'}=$4;
          next;
        }
      }else{next;}
      if($CR{$2.'_NAME'}&&$CR{$2.'_URL'}){
        $CR{$2.'_LINK'}=qq(<a href="$CR{$2.'_URL'}" title=")
        .(('VENDOR'eq$2)?'':'켡').qq(">$CR{$2.'_NAME'}</a>);
      }elsif($CR{$2.'_NAME'}){
        $CR{$2.'_LINK'}="$CR{$2.'_NAME'}";
      }
      next;
    }
  }
  ($i)&&(print WR "</tr></table>\n");
  if($#others>-1){
    print WR <<"_HTML_";
<table cellspacing="0" class="icon" summary="Others">
<caption>¾</caption>
<col span="$AT{'x'}" width="110" />
_HTML_
    
    my$i='1';
    my$j='-1';
    for(@others){
      my$text;
      $j++;
      $_=~m{^\s*<option (.*)value=(["'])(.+?)\2([^>]*)>([^<]*)(</option>)?$}io;
      if($j){#<td>
        $text=<<"_HTML_";
<td><img $1src="$CF{'icon'}$3" alt="$5"$4><br>$5</td>
_HTML_
        ($j>($AT{'x'}-2))&&($j=-1);
      }elsif($i==2){#</tr>+<tr>+<td>
        $text=<<"_HTML_";
</tr>
<tr>
<td><img $1src="$CF{'icon'}$3" alt=\"$5\"$4><br>$5</td>
_HTML_
      }elsif($i==1){#<tr>+<td>
        $text=<<"_HTML_";
<tr>
<td><img $1src="$CF{'icon'}$3" alt=\"$5\"$4><br>$5</td>
_HTML_
        $i=2;
      }
      print WR $text;next;
    }
    print WR "</tr></table>\n\n";
  }
  print WR $CF{'icfot'};
  print WR $CF{'pgfoot'};
  print WR <<"_HTML_";
<div class="AiremixCopy">- <a href="http://airemix.site.ne.jp/" target="_blank" title="Airemix - Mireille -">Airemix Mireille</a>
<var>$CF{'Manage'}</var> -</div>
</body>
</html>
_HTML_
  close(WR);

  &menu('ܹλ');
}

#-------------------------------------------------
# index.cgi
sub config{
my@required=(
 'name'   =>'Ȥ̾'
,'home'   =>'ȥȥåץڡURL'
,'title'  =>'ηǼĤΥȥTITLEǡ'
,'pgtitle'=>'ηǼĤΥȥʥڡΥإåɽ'
,'log'   =>'ǥ쥯ȥ'
,'icls'  =>'ꥹ'
,'icon'  =>'Υǥ쥯ȥ'
,'style' =>'륷'
,'navjs' =>'ʥJavaScript'
,'gzip'  =>'gzipξǤա'
);
    my@implied=(
 'admps' =>'ԥѥɡƤεԽǤޤ 25ʸʾ侩'
,'tags'  =>'ѤĤ륿Ⱦѥڡڤ'
,'strong'=>'Ĵ뵭бCSSΥ饹Ⱦѥڡڤǡֵ 饹 桦ס'
,'newnc' =>'Ƹ*****ðεNewޡĤ'
,'newuc' =>'ɤǤ???ô֤ϡ̤ɡ׾֤ݻ'
,'new'   =>'Ƹ*****ðεˤĤNewޡ'
,'page'  =>'̾⡼ɤǤ1ڡΥåɿ'
,'delpg' =>'⡼ɤǤ1ڡΥåɿ'
,'logmax'=>'祹åɿ'
,'sekitm'=>'Ǥܡ"ܤname ̾ "򤯤꤫'
,'prtitm'=>'Ƶι(+color +email +home +icon +ra +hua cmd +subject)'
,'chditm'=>'ҵι(+color +email +home +icon +ra +hua cmd)'
,'cokitm'=>'Cookieι(color email home icon)'
);
    my@select=(
 'colway'=>'ˡ','input INPUT select SELECT'
,'delold'=>'Ťåɤκˡ','gzip GZIP rename ե̾ѹ unlink ե'
,'delthr'=>'åɤκˡ','gzip GZIP rename ե̾ѹ unlink ե'
,'sort'  =>'¤ӽ','number ֹ date '
,'prtwrt'=>'ƥեIndexɽ','0 ɽʤ 1 ɽ'
,'mailnotify'=>'/ֿ äȤ˻ꥢɥ쥹˥᡼뤹','0 Ȥʤ 1 Ȥ'
);
    my@design=(
 'iched' =>'ꥹȤΥإå'
,'icfot' =>'ꥹȤΥեå'
);
  unless($IN{'name'}){
    my$message='';
    unless(&loadcfg){
      $message=<<'_HTML_';
<h2>configɤ߹ߤǥ顼ȯޤ</h2>
<p>config»Ƥǽޤ<br>
Τޤ޼¹ԤСconfig񤭤ꤷʤޤ</p>
_HTML_
    }
    for(%CF){
      $CF{"$_"}=~s/\t/\ \ /go;
      $CF{"$_"}=~s/&/&#38;/go;
      $CF{"$_"}=~s/"/&#34;/go;
      $CF{"$_"}=~s/'/&#39;/go;
      $CF{"$_"}=~s/</&#60;/go;
      $CF{"$_"}=~s/>/&#62;/go;
    }
    print<<"ASDF";
$AT{'head'}

<h2 class="mode">index.cgiԽ⡼</h2>
$message
<form accept-charset="euc-jp" name="cssedit" method="post" action="$AT{'manage'}">
<table style="margin:1em">
<col style="text-align:left;width:600px" /><col style="text-align:left;width:200px" />

<tbody>
<tr><th colspan="2"><h3 class="list">ư˳ǧ뤳</h2></th></tr>
ASDF
    my$i=0;
    #ư˳ǧ뤳
    for($i=0;$i<$#required;$i+=2){
      print<<"ASDF";
<tr>
<th class="item">$required[$i+1]</th>
<td><input name="$required[$i]" type="text" style="ime-mode:inactive;width:200px" value="$CF{"$required[$i]"}"></td>
</tr>
ASDF
    }

    print<<"ASDF";
<tr>
<th class="item">ॾ</td>
<td><input name="TZ" type="text" style="ime-mode:disabled" value="$ENV{'TZ'}"></td>
</tr>
</tbody>

<tbody>
<tr><th colspan="2"><h3 class="list">ɬפ˱ѹ</h2></th></tr>
ASDF
    #ɬפ˱ѹ
    for($i=0;$i<$#implied;$i+=2){
      print<<"ASDF";
<tr>
<th class="item">$implied[$i+1]</th>
<td><input name="$implied[$i]" type="text" style="ime-mode:inactive;width:200px" value="$CF{"$implied[$i]"}"></td>
</tr>
ASDF
    }

    #
    for($i=0;$i<$#select;$i+=3){
      print<<"ASDF";
<tr>
<th class="item">$select[$i+1]</th>
<td>
<select name="$select[$i]">
ASDF
      my$name=$select[$i+2];
      my@label=split(/ /o,$select[$i+2]);
      for(my$j=0;$j<$#label;$j+=2){
        if($label[$j]eq$CF{$select[$i]}){
          print<<"ASDF";
<option value="$label[$j]" selected="selected">$label[$j+1]</option>
ASDF
        }else{
          print<<"ASDF";
<option value="$label[$j]">$label[$j+1]</option>
ASDF
        }
      }
    print<<"ASDF";
</select>
</td>
</tr>
ASDF
    }
    print<<"ASDF";
</tbody>

<tbody>
<tr><th colspan="2"><h3 class="list">ѥ</h2></th></tr>
<tr>
<th class="item">ѥǽ</td>
ASDF
    $i=<<"ASDF";
<td>
<label for="exiconon">Ȥ<input id="exiconon" name="exicon" type="radio" value="1"
checked></label>
<label for="exiconof">Ȥʤ<input id="exiconof" name="exicon" type="radio" value="0"></label>
</td>
</tr>
<tr>
ASDF
    $i=~s/(value=\"$CF{'exicon'}\")/$1 checked="checked"/o;
    print$i;
    my@IC=keys%IC;
    for(0..($#IC+5)){
      my$key='';my$val='';
      if($_<=$#IC){
        $key=$IC[$_];
        $val=$IC{$IC[$_]}
      }
      print<<"ASDF";
<tr>
<th class="item">ѥɡ<input name="ICN$_" type="text" style="ime-mode:disabled" value="$key"></td>
<td>ե̾<input name="ICV$_" type="text" style="ime-mode:disabled" value="$val"></td>
</tr>
ASDF
    }
    print<<"ASDF";
<tr><th colspan="2"><h3 class="list">MireilleHTMLǥ</h2></th></tr>
ASDF
    #MireilleHTMLǥ
    for($i=0;$i<$#design;$i+=2){
      print<<"ASDF";
<tr><th class="item" colspan="2">$design[$i+1]</th></tr>
<tr><td colspan="2"><textarea name="$design[$i]" cols="130" rows="7" style="ime-mode:inactive;width:800px">$CF{$design[$i]}</textarea></td></tr>
ASDF
    }
    print<<"ASDF";
</table>
<p>
<input name="mode" type="hidden" value="config">
<input name="pass" type="hidden" value="$IN{'pass'}">
<input type="submit" accesskey="s" class="submit" value="OK"></p>
$AT{'foot'}
ASDF
  }else{
    for(keys%IN){
      $IN{"$_"}=~s/(\n)*$//;
      $IN{"$_"}=~s/^_CONFIG_$/(_CONFIG_)/gmo;
    }
    
    open(RD,"<$AT{'manage'}")||die"Can't read manage($AT{'manage'})[$!]";
    eval"flock(RD,1);";
    my$config=<RD>;
    close(RD);

    $config.=<<"ASDF";

#------------------------------------------------------------------------------#
# 'Mireille' Bulletin Board System
# - Mireille Index File -
#
# \$$CF{'Manage'}\$
# "This file is written in euc-jp, CRLF." 
# Scripted by NARUSE Yui.
#------------------------------------------------------------------------------#
require 5.005;
use Fcntl qw(:DEFAULT :flock);
use strict;
use vars qw(\%CF \%IC);
\$|=1;

#-------------------------------------------------
# ư˳ǧ뤳

ASDF
    my$i=0;
    for($i=0;$i<$#required;$i+=2){
      $config.=<<"ASDF";
#$required[$i+1]
\$CF{\'$required[$i]\'}=\'$IN{"$required[$i]"}\';
ASDF
    }
    $config.=<<"ASDF";
#ॾ
\$ENV{'TZ'}=\'$IN{'TZ'}\';

#-------------------------------------------------
# ɬפ˱ѹ

ASDF
    for($i=0;$i<$#implied;$i+=2){
      $config.=<<"ASDF";
#$implied[$i+1]
\$CF{\'$implied[$i]\'}=\'$IN{"$implied[$i]"}\';
ASDF
    }
    for($i=0;$i<$#select;$i+=3){
      $config.=<<"ASDF";
#$select[$i+1] ($select[$i+2])
\$CF{\'$select[$i]\'}=\'$IN{"$select[$i]"}\';
ASDF
    }
    $config.=<<"ASDF";
#ѥǽ (ON 1 OFF 0)
\$CF{'exicon'}=\'$IN{'exicon'}\';
#ѥ
#\$IC{'PASSWORD'}='FILENAME'; #NAME
#\$IC{'hae'}='mae.png'; #
#\$IC{'hie'}='mie.png'; #
#\$IC{'hue'}='mue.png'; #
#\$IC{'hee'}='mee.png'; #
#\$IC{'hoe'}='moe.png'; #ǵ
#㡧EXޥɤ"icon=moe"ǵѤ'moe.png'Ȥޤ
#ϤȤϡ\$IC{'hoe'}='moe.png'; #ǵפΤ褦ˡǽΡ#פΤ˺줺
ASDF
    for(my$i=0;defined$IN{"ICN$i"};$i++){
      ($IN{"ICN$i"}&&$IN{"ICV$i"})||(next);
      $config.=qq{\$IC{\'$IN{"ICN$i"}\'}=\'$IN{"ICV$i"}\';\n};
    }
    $config.=<<"ASDF";

#-------------------------------------------------
# MireilleHTMLǥ

ASDF
    for($i=0;$i<$#design;$i+=2){
      $config.=<<"ASDF";
#-----------------------------
# $design[$i+1]
\$CF{\'$design[$i]\'}=<<'_CONFIG_';
$IN{$design[$i]}
_CONFIG_

ASDF
    }
    $config.=<<'ASDF';
#-------------------------------------------------
# ¹ or ɤ߹ߡ

if($0 eq __FILE__){
  #ľܼ¹ԤäưФ
  require 'core.cgi';
  require 'style.pl';
  &main;
}

#-------------------------------------------------
# 
BEGIN{
  # Revision Number
ASDF
    $config.=qq(  \$CF{'Index'}=qq\$$CF{'Manage'}\$;);
    $config.=<<'ASDF';

  (getlogin)||(umask(0)); #'nobody'ä''͡
  # Mireille Error Screen 1.3
  if($0 eq __FILE__){
    $SIG{'__DIE__'}=sub{
      if($_[0]=~/^(?=.*?flock)(?=.*?unimplemented)/){return}
      print<<"_HTML_";
Content-Language: ja-JP
Content-type: text/plain; charset=euc-jp

<pre>
       :: Mireille ::
   * Error Screen 1.3 (o__)o// *

_HTML_
      ($_[0])&&(print"ERROR: $_[0]");
      print"\n";
      for(qw(Index Style Core Exte)){
        ($CF{"$_"})&&(print qq($_: $CF{"$_"}\n));
      }
      print"\n";
      for(qw(log icon icls style)){
        ($CF{"$_"})&&(print qq($_: $CF{"$_"}\n));
      }
      print"\ngetlogin : ".getlogin.<<"_HTML_";

PerlVer  : $]
PerlPath : $^X
BaseTime : $^T
OS Name  : $^O
FileName : $0

 = = ENV = =
_HTML_
      for(qw(CONTENT_LENGTH QUERY_STRING REQUEST_METHOD SERVER_NAME HTTP_HOST SCRIPT_NAME OS SERVER_SOFTWARE PROCESSOR_IDENTIFIER)){
        ($ENV{"$_"})&&(print qq($_:\t$ENV{"$_"}\n));
      }
      print<<"_HTML_";

+#     Airemix Mireille      #+
+#  http://www.airemix.com/  #+
_HTML_
      exit;
    };
  }
}

1;
__END__
ASDF
    open(WR,'+>>index.cgi')||die"Can't write index.cgi[$!]";
    eval"flock(WR,2);";
    truncate(WR,0);
    seek(WR,0,0);
    print WR $config;
    close(WR);
    
    &menu('index.cgi˽񤭹ߴλ');
  }
  exit;
}

#-------------------------------------------------
# CSSԽ
sub css{
  unless($IN{'file'}){
    print<<"ASDF";
$AT{'head'}
<h2 class="mode">륷ȥե</h2>
<form accept-charset="euc-jp" name="cssedit" method="post" action="$AT{'manage'}">
<p>CSSե̾<input name="file" type="text" style="ime-mode:disabled" value="$IN{'file'}">ʳĥҤϤʤ<br>
㡧$CF{'style'}ʤ顢styleȤϤ<br>
ΥƥݤΤǤΤǡ餺</p>
<p>
<input name="mode" type="hidden" value="css">
<input name="pass" type="hidden" value="$IN{'pass'}">
<input type="submit" accesskey="s" class="submit" value="OK"></p>
$AT{'foot'}
ASDF
  }elsif(!$IN{'css'}){
    open(RD,"<$IN{'file'}.css")||die"Can't read css($IN{'file'}.css)[$!]";
    eval"flock(RD,1);";
    my$css=join('',<RD>);
    close(RD);
    
    study$css;
    $css=~/\@charset\s*[\"\']([\-\w]*)[\"\']/io;
    $IN{'code'}=$1;
    ($IN{'code'}=~/Shift_JIS/io)&&($css=euc($css));
    $css=~s/\t/\ \ /go;
    $css=~s/&/&#38;/go;
    $css=~s/"/&#34;/go;
    $css=~s/'/&#39;/go;
    $css=~s/</&#60;/go;
    $css=~s/>/&#62;/go;
    
    print<<"ASDF";
$AT{'head'}
<h2 class="mode">륷Խ⡼</h2>
<form accept-charset="euc-jp" name="cssedit" method="post" action="$AT{'manage'}">
<p>CSSե̾:$IN{'file'}.css<input name="file" type="hidden" value="$IN{'file'}"><p>
<p><textarea name="css" cols="100" rows="15">$css</textarea><p>
<p>
<input name="code" type="hidden" value="$IN{'code'}">
<input name="mode" type="hidden" value="css">
<input name="pass" type="hidden" value="$IN{'pass'}">
<input type="submit" accesskey="s" class="submit" value="OK"></p>
$AT{'foot'}
ASDF
  }else{
    $IN{'css'}=~s/(\n)*$/\n/o;
    if($IN{'code'}=~/Shift_JIS/i){
      $IN{'css'}=sjis($IN{'css'});
    }
    open(WR,"+>>$IN{'file'}\.css")||die"Can't write css($IN{'file'}.css)[$!]";
    eval"flock(WR,2);";
    truncate(WR,0);
    seek(WR,0,0);
    print WR $IN{'css'};
    close(WR);
    
    &menu('css񤭹ߴλ');
  }
  exit;
}

#-------------------------------------------------
# 
sub log{
  unless($IN{'type'}){
    print<<"ASDF";
$AT{'head'}
<h2 class="mode">⡼</h2>
<form accept-charset="euc-jp" name="logedit" method="post" action="$AT{'manage'}">


<fieldset style="padding:0.5em;width:60%">
<legend>Хåå׺</legend>
<label for="back"><input name="type" id="back" type="radio" value="3" checked="checked">
Хååץե</label>
<pre style="text-align:center">ե̾ѹΤȤˤǤХååץեݤޤ</pre>
</fieldset>

<fieldset style="padding:0.5em;width:60%">
<legend>åɤ</legend>
<fieldset style="padding:0.5em;width:90%">
<legend></legend>
<input name="type" type="radio" value="1">
<input name="str" type="text" size="3" style="ime-mode:disabled" value="">

<input name="end" type="text" size="3" style="ime-mode:disabled" value="">
<pre style="text-align:center">ֹ梢ޤǺޤ
΢˲ʤäϡ0
΢˲ʤäϡǿĤƤΤΤΤޤ
ʤʥޥɤǤ⤢Τǡɬ¹˥ХååפȤ褦ˤޤ礦
</pre>
</fieldset>

<fieldset style="padding:0.5em;width:90%">
<legend>1(ǿ-)</legend>
<input name="type" type="radio" value="2">
<input name="save" type="text" size="3" style="ime-mode:disabled" value="">
<pre style="text-align:center">ǿ颢ĻĤơʳޤ
ǤֺǿפȤϵֹκǤ礭ʪΤȤǤ
ɬ¹˥ХååפȤ褦ˤޤ礦
</pre>
</fieldset>

<fieldset style="padding:0.5em;width:50%">
<legend accesskey="c"></legend>
<label for="rename">ե̾ѹ<input name="del" id="rename" type="radio" value="rename" checked></label>
<label for="unlink">ե<input name="del" id="unlink" type="radio" value="unlink"></label>
</fieldset>

<p><label for="push"><input id="push" name="push" type="checkbox" value="1">ֹĤ</label>
<br>ֹ򣱤֤ѹޤ</p>
</fieldset>

<p><input name="mode" type="hidden" value="log">
<input name="pass" type="hidden" value="$IN{'pass'}">
<input type="submit" accesskey="s" class="submit" value="OK"></p>
</form>
$AT{'foot'}
ASDF
  }elsif($IN{'type'}=~/^\d$/){
    print<<"ASDF";
$AT{'head'}
<h2 class="mode">⡼</h2>
<form accept-charset="euc-jp" name="logedit" method="post" action="$AT{'manage'}">
ASDF
    if($IN{'type'}==1){
      ($IN{'str'})||($IN{'str'}=1);
      ($IN{'end'})||($IN{'end'}=$IN{'str'},$IN{'str'}=1);
      print<<"ASDF";
<p>ˡ
<input name="str" type="text" size="3" value="$IN{'str'}" readonly>
<input name="end" type="text" size="3" value="$IN{'end'}" readonly>ƤǤ
<input name="type" type="hidden" value="a">
<input name="del" type="hidden" value="$IN{'del'}">
</p>
ASDF
      if($IN{'del'}eq'unlink'){
        print"<p>ե</p>";
      }else{
        print"<p>ե̾ѹ/p>";
      }
    }elsif($IN{'type'}==2){
      &loadcfg;
      my@file;
      opendir(DIR,$CF{'log'})||die"Can't read directory($CF{'log'})[$!]";
      for(readdir(DIR)){
        (($_=~/^(\d+).cgi$/io)&&($1))&&(push(@file,"$1"));
      }
      closedir(DIR);
      @file=sort{$b<=>$a}@file;
      my$i=$#file-$IN{'save'}+1;
      print<<"ASDF";
<p>ˡǿ
<input name="save" type="text" size="3" value="$IN{'save'}" readonly>ĻĤ
ƤǤ<input name="type" type="hidden" value="b"><br>
ֹ$file[$#file]$file[$IN{'save'}]ޤǤΡ$iޤ
<input name="del" type="hidden" value="$IN{'del'}">
</p>
ASDF
      if($IN{'del'}eq'unlink'){
        print"<p>ե</p>";
      }else{
        print"<p>ե̾ѹ/p>";
      }
    }elsif($IN{'type'}==3){
        print<<"ASDF";
<p>ˡХååץեݤƤǤ</p>
<input name="type" type="hidden" value="c">
ASDF
    }else{
      exit;
    }
    
    print<<"ASDF";
<br>
<p><a href="$AT{'manage'}" title="">ְ㤨ΤǺǽ餫ľ</a></p>
<br>
<p>
<input name="mode" type="hidden" value="log">
<input name="pass" type="hidden" value="$IN{'pass'}">
ͤ: <input name="push" type="text" size="3" value="$IN{'push'}" readonly></p>
<p><input type="submit" accesskey="s" class="submit" value="OK"></p>
</form>
$AT{'foot'}
ASDF
  }elsif($IN{'type'}=~/^\w$/){
    &loadcfg;
    if($IN{'type'}eq'a'){
      ($IN{'str'})||($IN{'str'}=1);
      ($IN{'end'})||($IN{'end'}=$IN{'str'},$IN{'str'}=1);
    }elsif($IN{'type'}eq'b'){
      my@file;
      opendir(DIR,$CF{'log'})||die"Can't read directory($CF{'log'})[$!]";
      for(readdir(DIR)){
        (($_=~/^(\d+).cgi$/io)&&($1))&&(push(@file,"$1"));
      }
      closedir(DIR);
      @file=sort{$b<=>$a}@file;#(4,3,2,1)
      $IN{'str'}=$file[$#file];
      $IN{'end'}=$file[$IN{'save'}];
    }elsif($IN{'type'}eq'c'){
      my$file=unlink<$CF{'log'}*.bak>;
      $file.=unlink<$CF{'log'}*.bak.cgi>;
      $file.=unlink<$CF{'log'}*.bak.pl>;
      $file.=unlink<$CF{'log'}*.gz>;
      &menu("$fileĤΥХååץեޤ");
    }else{
      exit;
    }

    my$file=0;
    if($IN{'del'}eq'unlink'){
      for($IN{'str'}..$IN{'end'}){
        (unlink"$CF{'log'}$_.cgi")||(next);
        $file++;
      }
    }else{
      for($IN{'str'}..$IN{'end'}){
        (rename("$CF{'log'}$_.cgi","$CF{'log'}$_.bak.cgi"))||(next);
        $file++;
      }
    }
    
    if($IN{'push'}){
      my@file;
      opendir(DIR,$CF{'log'})||die"Can't read directory($CF{'log'})[$!]";
      for(readdir(DIR)){
        (($_=~m/^(\d+).cgi$/io)&&($1))&&(push(@file,"$1"));
      }
      closedir(DIR);
      @file=sort{$a<=>$b}@file;#(1,2,3,4)
      
      open(ZERO,"+>>$CF{'log'}0.cgi")||die"Can't write log(0.cgi)[$!]";
      eval"flock(ZERO,2);";
      truncate(ZERO,0);
      seek(ZERO,0,0);
      my@zero=();
      while(<ZERO>){
        chomp$_;push(@zero,$_);
      }
      my@zer0=split("\t",$zero[0]);
      my@zer1=split(/ /,$zero[1]);
      my@zer2=split(/ /,$zero[2]);
      my@zerC=();
      my$zerD='';
      my$i=1;
      for(@file){
        rename("$CF{'log'}$_.cgi","$CF{'log'}$i.cgi")||die"Can't rename log($_.cgi->$i)[$!]";
        $zerC["$i"]=$zer2["$_"];
        $zerD.="$_=$i;";
        $i++;
      }
      $zerC[0]=0;
      chop$zerD;#Ǹ' '
      
      truncate(ZERO,0);
      seek(ZERO,0,0);
      print ZERO "@zer0\n";
      print ZERO "@zer1\n";
      print ZERO "@zerC\n";
      print ZERO "$zerD\n";#ե̾ѹΥ
      close(ZERO);
      
      &menu("$IN{'str'}$IN{'end'}Υե$fileĤλ<br>ͤ");
    }
    
    &menu("$IN{'str'}$IN{'end'}Υե$fileĤλ");
  }
  
  exit;
}

#-------------------------------------------------
# 0.cgiʵեˤβ
sub zero{
  unless($IN{'recover'}){
    print<<"ASDF";
$AT{'head'}
<h2 class="mode">ե⡼</h2>
<form accept-charset="euc-jp" name="zero" method="post" action="$AT{'manage'}">
<p>եꥫХꤹȡ¸ξϼޤ<br>
ǤǤ
<input name="mode" type="hidden" value="zero">
<input name="pass" type="hidden" value="$IN{'pass'}"></p>
<p><label accesskey="r" for="recover">
<input name="recover" id="recover" type="checkbox" value="1"></label></p>
<p><input type="submit" accesskey="s" class="submit" value="OK"></p>
$AT{'foot'}
ASDF
    exit;
  }else{
    &loadcfg;

    my@file=();
    my@zer2=();	
    
    opendir(DIR,$CF{'log'})||die"Can't read directory($CF{'log'})[$!]";
    for(readdir(DIR)){
      (($_=~/^(\d+).cgi$/io)&&($1))&&(push(@file,"$1"));
    }
    closedir(DIR);
    #ֹ 'number'
    @file=sort{$b<=>$a}@file;
    
    for(@file){
      $zer2[$_-$file[$#file]]=(stat("$CF{'log'}$_.cgi"))[9];
    }
    
    unshift(@zer2,$file[$#file]-1);
    
    open(ZERO,"+>>$CF{'log'}0.cgi")||die"Can't write log(0.cgi)[$!]";
    eval{flock(ZERO,2)};
    truncate(ZERO,0);
    seek(ZERO,0,0);
    print ZERO <<"ASDF";
Mir12=\t;\ttitle=\tեޤ;\tname=\tMireille;\tcolor=\t#fd0;\ttime=\t$^T;\t

@zer2
ASDF
    close(ZERO);
    &menu("եλ");
  }
  exit;
}


#-------------------------------------------------
# CGIΤδ
sub manage{
  unless($IN{'manage'}){
    print<<"ASDF";
$AT{'head'}
<h2 class="mode">CGIδ</h2>
<form accept-charset="euc-jp" name="zero" method="post" action="$AT{'manage'}">

<fieldset style="padding:0.5em;width:25em;text-align:left">
<legend accesskey="m">뤳(<span class="ak">M</span>)</legend>
<label accesskey="r" for="rename"><input name="manage" type="radio" id="rename" value="rename"
 checked>CGIե̾ѹ(<span class="ak">R</span>)</label>
<br>

<label accesskey="n" for="filename">ѹΥե̾(<span class="ak">N</span>)
&#34;<input name="filename" type="text" id="filename" value="">.cgi&#34;</label>
<br>
<label accesskey="u" for="unlink"><input name="manage" type="radio" id="unlink" value="unlink"
>CGIե(<span class="ak">U</span>)</label>
</fieldset>

<input name="mode" type="hidden" value="manage">
<input name="pass" type="hidden" value="$IN{'pass'}"></p>
<p><input type="submit" accesskey="s" class="submit" value="OK"></p>
$AT{'foot'}
ASDF
    exit;
  }else{
    if('rename'eq$IN{'manage'}){
      ($IN{'filename'})||(&menu('ѹΥե̾ϤƤޤǤ'));
      (rename(__FILE__,"$IN{'filename'}.cgi"))||(die"ѹ\n$!\nǤʤΤ⤷ʤ");
      &menu(qq(ե̾<a href="$IN{'filename'}.cgi">$IN{'filename'}.cgi</a>ѹޤ));
    }elsif('unlink'eq$IN{'manage'}){
      (unlink(__FILE__))||(die"\n$!\nǤʤΤ⤷ʤ");
      &menu("CGIޤ");
    }
  }
  exit;
}


#-------------------------------------------------
# configɤ߹
#
sub loadcfg{
  require 'index.cgi';
  require 'style.pl';
}

#------------------------------------------------------------------------------#
;# jcode.pl: Perl library for Japanese character code conversion
;# Copyright (c) 1992-2000 Kazumasa Utashiro <utashiro@iij.ad.jp>
;#  ftp://ftp.iij.ad.jp/pub/IIJ/dist/utashiro/perl/
sub euc{
  my($s,$icode)=($_[0],'');
  $s=~s/([\201-\237\340-\374][\100-\176\200-\374]|[\241-\337])/$::s2e{$1}||&s2e($1)/geo;
  return$s;
}
;# SJIS to EUC
sub s2e{
  my($c1,$c2,$code);
  ($c1,$c2)=unpack('CC',$code=shift);
  if(0xa1<=$c1&& $c1<=0xdf){
    $c2=$c1;$c1=0x8e;
  }elsif(0x9f<=$c2){
    $c1=$c1*2-($c1>=0xe0?0xe0:0x60);$c2+=2;
  }else{
    $c1=$c1*2-($c1>=0xe0?0xe1:0x61);$c2+=0x60+($c2<0x7f);
  }
  $::s2e{$code}=pack('CC',$c1,$c2);
}

sub sjis{
  my($s,$icode)=($_[0],'');
  $s=~s/([\241-\376][\241-\376]|\216[\241-\337]|\217[\241-\376][\241-\376])/$::e2s{$1}||&e2s($1)/geo;
  return$s;
}
;# EUC to SJIS
sub e2s{
  my($c1,$c2,$code);
  ($c1,$c2)=unpack('CC',$code=shift);
  if($c1==0x8e){#SS2
    return substr($code,1,1);
  }elsif($c1==0x8f){#SS3
    return"\x81\xac";
  }elsif($c1 % 2){
    $c1=($c1>>1)+($c1<0xdf?0x31:0x71);
    $c2-=0x60+($c2<0xe0);
  }else{
    $c1=($c1>>1)+($c1<0xdf?0x30:0x70);
    $c2-=2;
  }
  $::e2s{$code}=pack('CC',$c1,$c2);
}

#------------------------------------------------------------------------------#
# BEGIN

BEGIN{
  $CF{'Manage'}=q$Revision: 1.2.2.20 $;
  $CF{'style'} = 'style.css';
  $0=~m{/([^/\\::]+)$}o;
  $AT{'manage'}=$1;
  $AT{'head'}=<<"_HTML_";
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja-JP">
<head>
<meta http-equiv="Content-type" content="text/html; charset=euc-jp">
<meta http-equiv="Content-Script-Type" content="text/javascript">
<meta http-equiv="Content-Style-Type" content="text/css">
<link rel="stylesheet" href="$CF{'style'}" media="screen" type="text/css">
<title>Mireille Administrative Tools</title>
</head>

<body>

<table cellspacing="3" class="head" summary="Header">
<tr>
<th><h1 class="head" style="text-align:left;margin-left:0.5em">Mireille Administrative Tools</h1></th>
<td style="font-size:15px;text-align:right;letter-spacing:1em"></td>
</tr>
</table>
_HTML_

  $AT{'foot'}=<<"_HTML_";
<table cellspacing="3" class="head">
<tr>
<td style="font-size:15px;text-align:left;letter-spacing:1em"></td>
<th><h1 class="head" style="text-align:right;margin-right:0.5em">
<a href="./" style="color:#fff;font-size:17px;font-weight:normal">BACK to INDEX</a></h2></td>
</tr>
</table>

<div class="AiremixCopy">- <a href="http://www.airemix.com/" target="_blank" title="Airemix - Mireille -">Airemix Mireille</a>
<var>$CF{'Manage'}</var> -</div>
</body>
</html>
_HTML_

  # Mireille Error Screen 1.3
  if($0 eq __FILE__){
    $SIG{'__DIE__'}=sub{
      if($_[0]=~/^(?=.*?flock)(?=.*?unimplemented)/){return}
      print<<"_HTML_";
Content-Language: ja-JP
Content-type: text/plain; charset=euc-jp

<pre>
       :: Mireille ::
   * Error Screen 1.3 (o__)o// *

_HTML_
      ($_[0])&&(print"ERROR: $_[0]");
      print"\n";
      for(qw(Manage Index Style Core Exte)){
        ($CF{"$_"})&&(print qq($_: $CF{"$_"}\n));
      }
      print"\n";
      for(qw(log icon icls style)){
        ($CF{"$_"})&&(print qq($_: $CF{"$_"}\n));
      }
      print"\ngetlogin : ".getlogin.<<"_HTML_";

PerlVer  : $]
PerlPath : $^X
BaseTime : $^T
OS Name  : $^O
FileName : $0

 = = ENV = =
_HTML_
      for(qw(CONTENT_LENGTH QUERY_STRING REQUEST_METHOD SERVER_NAME HTTP_HOST SCRIPT_NAME OS SERVER_SOFTWARE PROCESSOR_IDENTIFIER)){
        ($ENV{"$_"})&&(print qq($_:\t$ENV{"$_"}\n));
      }
      print<<"_HTML_";

+#     Airemix Mireille      #+
+#  http://www.airemix.com/  #+
_HTML_
      exit;
    };
  }
}

1;
__END__
